#include <cstdint>
#include <cstdlib>

#include "type.h"
#include "typetree.h"
#include "nametree.h"
#include "pool.h"

#include "schema.h"

extern TypeTree DB_TYPE;
extern NameTree DB_NAME;
extern Pool<Variable> DB_DATA;

extern "C" size_t type_outer(size_t id, size_t key);
extern "C" size_t type_inner(size_t id);
extern "C" size_t type_key(size_t id);
extern "C" size_t type_size(size_t type_id);

void* allocate(size_t type_id, size_t count);
extern "C" Variable acquire(size_t type_id);
extern "C" void release(Variable id);
extern "C" bool copy(Variable src, Variable dst);

// Varying //
extern "C" Variable varying_get(Variable addr);
extern "C" void varying_set(Variable addr, Variable source);
extern "C" void varying_clear(Variable addr);

// Boolean //
extern "C" void bool_set(Variable addr, Type::Boolean value);
extern "C" Type::Boolean bool_get(Variable addr);

// Natural //p
extern "C" void natural_set(Variable addr, Type::Natural value);
extern "C" Type::Natural natural_get(Variable addr);

// Integer //
extern "C" void integer_set(Variable addr, Type::Integer value);
extern "C" Type::Integer integer_get(Variable addr);

// Block //
extern "C" uint8_t block_get(Variable addr, size_t index);
extern "C" void block_set(Variable addr, size_t index, uint8_t value);

// String //
//extern "C" size_t string_length(Variable addr);
//extern "C" Variable string_get(Variable addr, size_t index);
//extern "C" void string_clear(Variable addr);
//extern "C" void string_prepend(Variable addr, Variable source);
//extern "C" void string_append(Variable addr, Variable source);
//extern "C" void string_insert(Variable addr, size_t index, Variable source);
//extern "C" void string_set(Variable addr, size_t index, Variable source);
//extern "C" void string_truncate(Variable addr, size_t maximum);
//extern "C" void string_remove(Variable addr, size_t index, size_t maximum);

// Array //
extern "C" size_t array_length(Variable addr);
Variable array_cell(Variable addr, size_t index);
extern "C" Variable array_get(Variable addr, size_t index);
extern "C" void array_set(Variable addr, size_t index, Variable source);

// List //

extern "C" size_t list_capacity(Variable addr);
extern "C" size_t list_length(Variable addr);
Variable list_cell(Variable addr, size_t index);
extern "C" Variable list_at(Variable addr, size_t index);
//extern "C" Variable list_first(Variable addr);
//extern "C" Variable list_last(Variable addr);
extern "C" void list_clear(Variable addr);
//extern "C" void list_prepend(Variable addr, Variable source);
//extern "C" void list_append(Variable addr, Variable source);
extern "C" void list_insert(Variable addr, size_t index, Variable source);
extern "C" void list_update(Variable addr, size_t index, Variable source);
//extern "C" void list_truncate(Variable addr, size_t maximum);
//extern "C" void list_shift(Variable addr);
extern "C" void list_remove(Variable addr, size_t index, size_t maximum);
extern "C" void list_reserve(Variable addr, size_t capacity);
//extern "C" void list_resize(Variable addr, size_t length);

// Record //

// Schema //
