#include <cstdint>

extern "C" struct Variable {
    size_t type;
    void*  address;
};

namespace Type {

namespace Tag {
    enum {
        Varying = 0x00,
        Null    = 0x01,
        Boolean = 0x02,
        Natural = 0x10,
        Integer = 0x11,
        Block   = 0x1e,
        String  = 0x1f,
        //Optional = 0x20,
        //Set     = 0x21,
        Array   = 0x22,
        List    = 0x23,
        Sparse  = 0x24,
        //Trie    = 0x27,
        //Map     = 0x28,
        Record  = 0x4e,
        Schema  = 0x4f,
    };
}

typedef bool     Boolean;
typedef uint64_t Natural;
typedef int64_t  Integer;

struct List {
    size_t capacity;
    size_t length;
    void*  data;
};

struct Schema {
    size_t capacity;
    size_t length;
    void*  data;
};

}
